diff --git a/src/john.c b/src/john.c
index 53b6434353..e04c3be3e5 100644
--- a/src/john.c
+++ b/src/john.c
@@ -1606,10 +1606,11 @@ static void john_run(void)
 		}
 
 		if (!(options.flags & FLG_STDOUT)) {
-			struct db_main *test_db;
+			struct db_main *test_db = 0;
 			char *where;
 
-			test_db = ldr_init_test_db(database.format, &database);
+			if ( (options.flags & FLG_NOTESTS) == 0)
+				test_db = ldr_init_test_db(database.format, &database);
 			where = fmt_self_test(database.format, test_db);
 			ldr_free_test_db(test_db);
 			if (where) {
